/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (C) 2020 Loongson Technology Co., Ltd.
 */

#ifndef _LOONGARCH_SETUP_H
#define _LOONGARCH_SETUP_H

#include <linux/types.h>
#include <uapi/asm/setup.h>

extern void prom_putchar(char);
extern void setup_early_printk(void);

#ifdef CONFIG_EARLY_PRINTK_8250
extern void setup_8250_early_printk_port(unsigned long base, unsigned int reg_shift);
#else
static inline void setup_8250_early_printk_port(unsigned long base, unsigned int reg_shift) {}
#endif

extern void set_handler(unsigned long offset, void *addr, unsigned long len);
extern void set_merr_handler(unsigned long offset, void *addr, unsigned long len);

typedef void (*vi_handler_t)(void);
extern void set_vi_handler(int n, vi_handler_t addr);

extern unsigned long ebase;
extern unsigned long merr_ebase;
extern unsigned long refill_ebase;
extern void boot_cpu_trap_init(void);
extern void nonboot_cpu_trap_init(void);
extern void cpu_cache_init(void);

#endif /* __SETUP_H */
