/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (C) 2020 Loongson Technology Corporation Limited
 */

#ifndef __ASM_UASM_H
#define __ASM_UASM_H

#include <linux/types.h>

#ifdef CONFIG_EXPORT_UASM
#include <linux/export.h>
#define UASM_EXPORT_SYMBOL(sym) EXPORT_SYMBOL(sym)
#else
#define UASM_EXPORT_SYMBOL(sym)
#endif

#define Ip_u2s1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, signed int b)

#define Ip_u2s20(op)							\
void uasm_i##op(u32 **buf, unsigned int a, signed int b)

#define Ip_u2s15(op)							\
void uasm_i##op(u32 **buf, unsigned int a, signed int b)

#define Ip_u2u1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b)

#define Ip_s1(op)							\
void uasm_i##op(u32 **buf, signed int a)

#define Ip_s26(op)							\
void uasm_i##op(u32 **buf, signed int a)

#define Ip_u2u3s1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, signed int c)

#define Ip_u3u2u1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, unsigned int c)

#define Ip_s3u2u1(op)							\
void uasm_i##op(u32 **buf, signed int a, unsigned int b, unsigned int c)

#define Ip_u3u2s1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, signed int c)

#define Ip_u4u3s2u1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, signed int c, \
							  unsigned int d)

#define Ip_u4u3u1u2(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, unsigned int c, \
			unsigned int d)

#define Ip_u4u3u2u1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, unsigned int c, \
							  unsigned int d)

#define Ip_u1u2u3(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, unsigned int c)

#define Ip_u2u1u3(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, unsigned int c)

#define Ip_u3u2u1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, unsigned int c)

#define Ip_u3u1u2(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, unsigned int c)

#define Ip_u1u2s3(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, signed int c)

#define Ip_u2s3u1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, signed int b, unsigned int c)

#define Ip_s3s1s2(op)							\
void uasm_i##op(u32 **buf, int a, int b, int c)

#define Ip_u4u2u1s3(op)						\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, signed int c, \
	   unsigned int d)

#define Ip_u2u1s3(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, signed int c)

#define Ip_u2u1msbu3(op)						\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b, unsigned int c, \
	   unsigned int d)

#define Ip_u1u2(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b)

#define Ip_u2u1(op)							\
void uasm_i##op(u32 **buf, unsigned int a, unsigned int b)

#define Ip_u1s2(op)							\
void uasm_i##op(u32 **buf, unsigned int a, signed int b)

#define Ip_u1(op) void uasm_i##op(u32 **buf, unsigned int a)

#define Ip_0(op) void uasm_i##op(u32 **buf)

Ip_u2s1(_lu12iw);
Ip_u2s1(_lu32id);
Ip_u2s15(_bceqz);
Ip_u2s15(_bcnez);
Ip_s26(_jiscr0);
Ip_s26(_jiscr1);
Ip_u3u2s1(_jirl);
Ip_s1(_b);
Ip_s1(_bl);
Ip_u2u3s1(_beq);
Ip_u2u3s1(_bne);
Ip_u2u3s1(_blt);
Ip_u2u3s1(_bge);
Ip_u2u3s1(_bltu);
Ip_u2u3s1(_bgeu);
Ip_u2u1(_gr2scr);
Ip_u2u1(_scr2gr);
Ip_u2u1(_clow);
Ip_u2u1(_clzw);
Ip_u2u1(_ctow);
Ip_u2u1(_ctzw);
Ip_u2u1(_clod);
Ip_u2u1(_clzd);
Ip_u2u1(_ctod);
Ip_u2u1(_ctzd);
Ip_u2u1(_revb2h);
Ip_u2u1(_revb4h);
Ip_u2u1(_revb2w);
Ip_u2u1(_revbd);
Ip_u2u1(_revh2w);
Ip_u2u1(_revhd);
Ip_u2u1(_bitrev4b);
Ip_u2u1(_bitrev8b);
Ip_u2u1(_bitrevw);
Ip_u2u1(_bitrevd);
Ip_u2u1(_extwh);
Ip_u2u1(_extwb);
Ip_u2u1(_rdtimelw);
Ip_u2u1(_rdtimehw);
Ip_u2u1(_rdtimed);
Ip_u2u1(_cpucfg);
Ip_u2u1(_movgr2fcsr);
Ip_u2u1(_movfcsr2gr);
Ip_u2u1(_movgr2cf);
Ip_u2u1(_movcf2gr);
Ip_u3u2u1(_rotrib);
Ip_u3u2u1(_rcrib);
Ip_u3u2u1(_rotrih);
Ip_u3u2u1(_rcrih);
Ip_u3u2u1(_slliw);
Ip_u3u2u1(_srliw);
Ip_u3u2u1(_sraiw);
Ip_u3u2u1(_rotriw);
Ip_u3u2u1(_rcriw);
Ip_u3u2u1(_sllid);
Ip_u3u2u1(_srlid);
Ip_u3u2u1(_sraid);
Ip_u3u2u1(_rotrid);
Ip_u3u2u1(_rcrid);
Ip_u4u3u1u2(_bstrinsw);
Ip_u4u3u1u2(_bstrpickw);
Ip_u4u3u1u2(_bstrinsd);
Ip_u4u3u1u2(_bstrpickd);
Ip_u3u2s1(_slti);
Ip_u3u2s1(_sltui);
Ip_u3u2s1(_addiw);
Ip_u3u2s1(_addid);
Ip_u3u2s1(_lu52id);
Ip_u3u2u1(_andi);
Ip_u3u2u1(_ori);
Ip_u3u2u1(_xori);
Ip_u3u2u1(_cache);
Ip_u3u2s1(_llw);
Ip_u3u2s1(_scw);
Ip_u3u2s1(_lld);
Ip_u3u2s1(_scd);
Ip_u3u2s1(_ldptrw);
Ip_u3u2s1(_stptrw);
Ip_u3u2s1(_ldptrd);
Ip_u3u2s1(_stptrd);
Ip_u3u2s1(_ldb);
Ip_u3u2s1(_ldh);
Ip_u3u2s1(_ldw);
Ip_u3u2s1(_ldd);
Ip_u3u2s1(_stb);
Ip_u3u2s1(_sth);
Ip_u3u2s1(_stw);
Ip_u3u2s1(_std);
Ip_u3u2s1(_ldbu);
Ip_u3u2s1(_ldhu);
Ip_u3u2s1(_ldwu);
Ip_u3u2s1(_preld);
Ip_u3u2s1(_ldlw);
Ip_u3u2s1(_ldrw);
Ip_u3u2s1(_ldld);
Ip_u3u2s1(_ldrd);
Ip_u3u2s1(_stlw);
Ip_u3u2s1(_strw);
Ip_u3u2s1(_stld);
Ip_u3u2s1(_strd);
Ip_u3u2s1(_addu16id);
Ip_u2u1(_asrtled);
Ip_u2u1(_asrtgtd);
Ip_u3u2u1(_addw);
Ip_u3u2u1(_addd);
Ip_u3u2u1(_subw);
Ip_u3u2u1(_subd);
Ip_u3u2u1(_slt);
Ip_u3u2u1(_sltu);
Ip_u3u2u1(_maskeqz);
Ip_u3u2u1(_masknez);
Ip_u3u2u1(_nor);
Ip_u3u2u1(_and);
Ip_u3u2u1(_or);
Ip_u3u2u1(_xor);
Ip_u3u2u1(_orn);
Ip_u3u2u1(_andn);
Ip_u3u2u1(_sllw);
Ip_u3u2u1(_srlw);
Ip_u3u2u1(_sraw);
Ip_u3u2u1(_slld);
Ip_u3u2u1(_srld);
Ip_u3u2u1(_srad);
Ip_u3u2u1(_rotrb);
Ip_u3u2u1(_rotrh);
Ip_u3u2u1(_rotrw);
Ip_u3u2u1(_rotrd);
Ip_u3u2u1(_mulw);
Ip_u3u2u1(_mulhw);
Ip_u3u2u1(_mulhwu);
Ip_u3u2u1(_muld);
Ip_u3u2u1(_mulhd);
Ip_u3u2u1(_mulhdu);
Ip_u3u2u1(_mulwdw);
Ip_u3u2u1(_mulwdwu);
Ip_u3u2u1(_divw);
Ip_u3u2u1(_modw);
Ip_u3u2u1(_divwu);
Ip_u3u2u1(_modwu);
Ip_u3u2u1(_divd);
Ip_u3u2u1(_modd);
Ip_u3u2u1(_divdu);
Ip_u3u2u1(_moddu);
Ip_u3u2u1(_crcwbw);
Ip_u3u2u1(_crcwhw);
Ip_u3u2u1(_crcwww);
Ip_u3u2u1(_crcwdw);
Ip_u3u2u1(_crccwbw);
Ip_u3u2u1(_crccwhw);
Ip_u3u2u1(_crccwww);
Ip_u3u2u1(_crccwdw);
Ip_s3u2u1(_addu12iw);
Ip_s3u2u1(_addu12id);
Ip_u3u2u1(_adcb);
Ip_u3u2u1(_adch);
Ip_u3u2u1(_adcw);
Ip_u3u2u1(_adcd);
Ip_u3u2u1(_sbcb);
Ip_u3u2u1(_sbch);
Ip_u3u2u1(_sbcw);
Ip_u3u2u1(_sbcd);
Ip_u3u2u1(_rcrb);
Ip_u3u2u1(_rcrh);
Ip_u3u2u1(_rcrw);
Ip_u3u2u1(_rcrd);
Ip_u3u2u1(_ldxb);
Ip_u3u2u1(_ldxh);
Ip_u3u2u1(_ldxw);
Ip_u3u2u1(_ldxd);
Ip_u3u2u1(_stxb);
Ip_u3u2u1(_stxh);
Ip_u3u2u1(_stxw);
Ip_u3u2u1(_stxd);
Ip_u3u2u1(_ldxbu);
Ip_u3u2u1(_ldxhu);
Ip_u3u2u1(_ldxwu);
Ip_u3u2u1(_preldx);
Ip_u3u2u1(_amswapw);
Ip_u3u2u1(_amswapd);
Ip_u3u2u1(_amaddw);
Ip_u3u2u1(_amaddd);
Ip_u3u2u1(_amandw);
Ip_u3u2u1(_amandd);
Ip_u3u2u1(_amorw);
Ip_u3u2u1(_amord);
Ip_u3u2u1(_amxord);
Ip_u3u2u1(_amxorw);
Ip_u3u2u1(_ammaxw);
Ip_u3u2u1(_ammaxd);
Ip_u3u2u1(_amminw);
Ip_u3u2u1(_ammind);
Ip_u3u2u1(_ammaxwu);
Ip_u3u2u1(_ammaxdu);
Ip_u3u2u1(_amminwu);
Ip_u3u2u1(_ammindu);
Ip_u3u2u1(_amswap_dbw);
Ip_u3u2u1(_amswap_dbd);
Ip_u3u2u1(_amadd_dbw);
Ip_u3u2u1(_amadd_dbd);
Ip_u3u2u1(_amand_dbw);
Ip_u3u2u1(_amand_dbd);
Ip_u3u2u1(_amor_dbw);
Ip_u3u2u1(_amor_dbd);
Ip_u3u2u1(_amxor_dbw);
Ip_u3u2u1(_amxor_dbd);
Ip_u3u2u1(_ammax_dbw);
Ip_u3u2u1(_ammax_dbd);
Ip_u3u2u1(_ammin_dbw);
Ip_u3u2u1(_ammin_dbd);
Ip_u3u2u1(_ammax_dbwu);
Ip_u3u2u1(_ammax_dbdu);
Ip_u3u2u1(_ammin_dbwu);
Ip_u3u2u1(_ammin_dbdu);
Ip_u3u2u1(_ldgtb);
Ip_u3u2u1(_ldgth);
Ip_u3u2u1(_ldgtw);
Ip_u3u2u1(_ldgtd);
Ip_u3u2u1(_ldleb);
Ip_u3u2u1(_ldleh);
Ip_u3u2u1(_ldlew);
Ip_u3u2u1(_ldled);
Ip_u3u2u1(_stgtb);
Ip_u3u2u1(_stgth);
Ip_u3u2u1(_stgtw);
Ip_u3u2u1(_stgtd);
Ip_u3u2u1(_stleb);
Ip_u3u2u1(_stleh);
Ip_u3u2u1(_stlew);
Ip_u3u2u1(_stled);
Ip_u1(_break);
Ip_u1(_dbgcall);
Ip_u1(_syscall);
Ip_u1(_hypcall);
Ip_u1(_dbar);
Ip_u1(_ibar);
Ip_u4u3u2u1(_alslw);
Ip_u4u3u2u1(_alslwwu);
Ip_u4u3u2u1(_bytepickw);
Ip_u4u3u2u1(_alsld);
Ip_u4u3u2u1(_bytepickd);
Ip_u2u1(_iocsrrdb);
Ip_u2u1(_iocsrrdh);
Ip_u2u1(_iocsrrdw);
Ip_u2u1(_iocsrrdd);
Ip_u2u1(_iocsrwrb);
Ip_u2u1(_iocsrwrh);
Ip_u2u1(_iocsrwrw);
Ip_u2u1(_iocsrwrd);
Ip_0(_tlbinv);
Ip_0(_gtlbinv);
Ip_0(_tlbflush);
Ip_0(_gtlbflush);
Ip_0(_tlbp);
Ip_0(_gtlbp);
Ip_0(_tlbr);
Ip_0(_gtlbr);
Ip_0(_tlbwi);
Ip_0(_gtlbwi);
Ip_0(_tlbwr);
Ip_0(_gtlbwr);
Ip_u3u2u1(_lddir);
Ip_u2u1(_ldpte);
Ip_u2u1(_csrrd);
Ip_u2u1(_csrwr);
Ip_u3u2u1(_csrxchg);
Ip_u2u1(_gcsrrd);
Ip_u2u1(_gcsrwr);
Ip_u3u2u1(_gcsrxchg);
Ip_0(_eret);
Ip_u1(_wait);

/* Handle labels. */
struct uasm_label {
	u32 *addr;
	int lab;
};

void uasm_build_label(struct uasm_label **lab, u32 *addr,
			int lid);
#ifdef CONFIG_64BIT
int uasm_in_compat_space_p(long addr);
#endif
int uasm_rel_hi20(long val);
int uasm_rel_lo12(long val);
void UASM_i_LA_mostly(u32 **buf, unsigned int rs, long addr);
void UASM_i_LA(u32 **buf, unsigned int rs, long addr);

#define UASM_L_LA(lb)							\
static inline void uasm_l##lb(struct uasm_label **lab, u32 *addr)	\
{									\
	uasm_build_label(lab, addr, label##lb);				\
}

/* convenience macros for instructions */
# define UASM_i_ADDIU(buf, rs, rt, val) uasm_i_addid(buf, rs, rt, val)
# define UASM_i_ADDU(buf, rs, rt, rd) uasm_i_addd(buf, rs, rt, rd)
# define UASM_i_LL(buf, rs, rt, off) uasm_i_lld(buf, rs, rt, off)
# define UASM_i_LW(buf, rs, rt, off) uasm_i_ldd(buf, rs, rt, off)
# define UASM_i_LWX(buf, rs, rt, rd) uasm_i_ldx(buf, rs, rt, rd)
# define UASM_i_ROTR(buf, rs, rt, sh) uasm_i_rotrid(buf, rs, rt, sh)
# define UASM_i_SC(buf, rs, rt, off) uasm_i_scd(buf, rs, rt, off)
# define UASM_i_SLL(buf, rs, rt, sh) uasm_i_sllid(buf, rs, rt, sh)
# define UASM_i_SRA(buf, rs, rt, sh) uasm_i_sraid(buf, rs, rt, sh)
# define UASM_i_SRL(buf, rs, rt, sh) uasm_i_srlid(buf, rs, rt, sh)
# define UASM_i_SRL_SAFE(buf, rs, rt, sh) uasm_i_dsrl_safe(buf, rs, rt, sh)
# define UASM_i_SUBU(buf, rs, rt, rd) uasm_i_subd(buf, rs, rt, rd)
# define UASM_i_SW(buf, rs, rt, off) uasm_i_std(buf, rs, rt, off)

#define uasm_i_beqz(buf, rs, off) uasm_i_beq(buf, rs, 0, off)
#define uasm_i_bnez(buf, rs, off) uasm_i_bne(buf, rs, 0, off)
#define uasm_i_bltz(buf, rs, off) uasm_i_blt(buf, rs, 0, off)
#define uasm_i_bgez(buf, rs, off) uasm_i_bge(buf, rs, 0, off)
#define uasm_i_move(buf, a, b) uasm_i_or(buf, a, 0, b)

static inline void uasm_i_drotr_safe(u32 **p, unsigned int a1,
				     unsigned int a2, unsigned int a3)
{
	uasm_i_rotrid(p, a1, a2, a3);
}

static inline void uasm_i_dsll_safe(u32 **p, unsigned int a1,
				    unsigned int a2, unsigned int a3)
{
	uasm_i_sllid(p, a1, a2, a3);
}

static inline void uasm_i_dsrl_safe(u32 **p, unsigned int a1,
				    unsigned int a2, unsigned int a3)
{
	uasm_i_srlid(p, a1, a2, a3);
}

static inline void uasm_i_dsra_safe(u32 **p, unsigned int a1,
				    unsigned int a2, unsigned int a3)
{
	uasm_i_sraid(p, a1, a2, a3);
}

/* Handle relocations. */
struct uasm_reloc {
	u32 *addr;
	unsigned int type;
	int lab;
};

/* This is zero so we can use zeroed label arrays. */
#define UASM_LABEL_INVALID 0

void uasm_r_loongarch_pc16(struct uasm_reloc **rel, u32 *addr, int lid);
void uasm_r_loongarch_pc21(struct uasm_reloc **rel, u32 *addr, int lid);
void uasm_r_loongarch_pc26(struct uasm_reloc **rel, u32 *addr, int lid);
void uasm_resolve_relocs(struct uasm_reloc *rel, struct uasm_label *lab);
void uasm_move_relocs(struct uasm_reloc *rel, u32 *first, u32 *end, long off);
void uasm_move_labels(struct uasm_label *lab, u32 *first, u32 *end, long off);
void uasm_copy_handler(struct uasm_reloc *rel, struct uasm_label *lab,
	u32 *first, u32 *end, u32 *target);
void uasm_il_beqz(u32 **p, struct uasm_reloc **r, unsigned int reg, int lid);
void uasm_il_bnez(u32 **p, struct uasm_reloc **r, unsigned int reg, int lid);
void uasm_il_bceqz(u32 **p, struct uasm_reloc **r, unsigned int reg, int lid);
void uasm_il_bcnez(u32 **p, struct uasm_reloc **r, unsigned int reg, int lid);
void uasm_il_jiscr0(u32 **p, struct uasm_reloc **r, int lid);
void uasm_il_jiscr1(u32 **p, struct uasm_reloc **r, int lid);
void uasm_il_jirl(u32 **p, struct uasm_reloc **r, unsigned int r1,
		 unsigned int r2, int lid);
void uasm_il_b(u32 **p, struct uasm_reloc **r, int lid);
void uasm_il_bl(u32 **p, struct uasm_reloc **r, int lid);
void uasm_il_beq(u32 **p, struct uasm_reloc **r, unsigned int r1,
		 unsigned int r2, int lid);
void uasm_il_bne(u32 **p, struct uasm_reloc **r, unsigned int reg1,
		 unsigned int reg2, int lid);
void uasm_il_blt(u32 **p, struct uasm_reloc **r, unsigned int reg1,
		 unsigned int reg2, int lid);
void uasm_il_bge(u32 **p, struct uasm_reloc **r, unsigned int reg1,
		 unsigned int reg2, int lid);
void uasm_il_bltu(u32 **p, struct uasm_reloc **r, unsigned int reg1,
		 unsigned int reg2, int lid);
void uasm_il_bgeu(u32 **p, struct uasm_reloc **r, unsigned int reg1,
		 unsigned int reg2, int lid);

/* Convenience functions for labeled branches. */
void uasm_il_bgez(u32 **p, struct uasm_reloc **r, unsigned int reg, int lid);
void uasm_il_bltz(u32 **p, struct uasm_reloc **r, unsigned int reg, int lid);

#endif /* __ASM_UASM_H */
