#!/bin/bash

set -x

make mrproper ARCH=arm64 -j8
make mrproper ARCH=mips -j8
make mrproper ARCH=x86 -j8
git clean -xdf
make distclean -j8
fakeroot ./debian/rules clean
echo -n `git rev-parse HEAD` > .sourceversion
dpkg-buildpackage -S -us

changelog=`dpkg-parsechangelog -ldebian/changelog -o0 -c0 | sed -ne 's/^Version: *//p'`
debsign --re-sign  -p "gpg --passphrase-fd 0 --pinentry-mode loopback" ../linux_${changelog}_source.changes << EOF
123123
EOF
dput lpdev:~liuyun01/kylin/kernel-v10.1 ../linux_${changelog}_source.changes
